require "syncmind/version"

# SyncMind::PersonalityQuiz.create_data_folder

module Syncmind
  class Error < StandardError; end
  
  class PersonalityQuiz
    def self.create_data_folder  # Creates a data folder on your computer with placeholder script if it doesn't exist.
      if File.directory?("data")
        puts "Data directory already exists."
      else
        system("mkdir data")
      
        open("data/script.txt", "w") { |f|
          f.puts "Hello World"
        }
      end
    end
  
    # Do you rely on memory or list making?
    def self.memory
      system("clear")
    
      print "
      Do you rely on memory or list making?
      
      [A] Let me make a list of that.
      [B] I will try and remember that.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me make a list of that."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I will try and remember that."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I will try and remember that."
          
          f.puts old_script
        }
      end
    end
    
    # Do you tend to rely on faith or evidence?
    def self.critical_thinking
      system("clear")
    
      print "
      Do you prefer to see the evidence, or have faith?
      
      [A] I want to see the evidence.
      [B] I shall have faith in it.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to see the evidence."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I shall have faith in it."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I shall have faith in it."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer to be alone or with others?
    def self.alone_time
      system("clear")
    
      print "
      Do you prefer to be alone or with others?
      
      [A] Will you leave me alone.
      [B] I want to be with you.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Will you leave me alone."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to be with you."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to be with you."
          
          f.puts old_script
        }
      end
    end
    
    # Do you accept things the way they are?
    def self.accepts_things
      system("clear")
    
      print "
      Do you prefer to accept things the way they are?
      
      [A] I shall accept what you say.
      [B] I want to try to change your mind.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I shall accept what you say."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to try to change your mind."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to try to change your mind."
          
          f.puts old_script
        }
      end
    end
    
    # Do you keep a clean room or not?
    def self.cleanliness
      system("clear")
    
      print "
      Do you keep a clean room?
      
      [A] I think I'll try to clean my room.
      [B] I think I will clean my room later.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I'll try to clean my room."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I will clean my room later."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I will clean my room later."
          
          f.puts old_script
        }
      end
    end
    
    # Do you make decisions first or think through them?
    def self.automatic_decisions
      system("clear")
    
      print "
      Do you prefer to act and think later?
      
      [A] I want to have some action.
      [B] Let me think first!
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to have some action."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me think first!"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me think first!"
          
          f.puts old_script
        }
      end
    end
    
    # Are you always mellow or do you relax?
    def self.relaxation_check
      system("clear")
    
      print "
      Do you like to relax?
      
      [A] I want to smoke a joint!
      [B] Your question is making me nervous.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to smoke a joint!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Your question is making me nervous."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Your question is making me nervous."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer yes or no answers, or multiple choice?
    def self.easy_answers
      system("clear")
    
      print "
      Do you like your questions simple?
      
      [A] Do I have any nuanced choices?
      [B] Give me a yes or no question.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Do I have any nuanced choices?"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a yes or no question."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a yes or no question."
          
          f.puts old_script
        }
      end
    end
    
    # Do you like things to be chaotic or organized?
    def self.organizational
      system("clear")
    
      print "
      Do you like causing chaos for other people?
      
      [A] I want to see whose life I can ruin.
      [B] Lets try to keep life as simple and orderly as possible.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Do I have any nuanced choices?"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a yes or no question."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a yes or no question."
          
          f.puts old_script
        }
      end
    end
    
    # Do you easily get your feelings hurt?
    def self.hurt_feelings
      system("clear")
    
      print "
      Do you easile get your feelings hurt?
      
      [A] You hurt my feelings!
      [B] You didn't hurt my feelings.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "You hurt my feelings!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "You didn't hurt my feelings."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "You didn't hurt my feelings."
          
          f.puts old_script
        }
      end
    end
    
    # Do you work best in groups, or work best alone?
    def self.group_focus
      system("clear")
    
      print "
      Do you like to work with other people?
      
      [A] I want to find a team mate to work with.
      [B] I want to me left alone so I can work.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to find a team mate to work with."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to me left alone so I can work."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to me left alone so I can work."
          
          f.puts old_script
        }
      end
    end
    
    # Do you focus on the past, present, or future?
    def self.retrospective
      system("clear")
    
      print "
      Do you live moment to moment?
      
      [A] I want to remember something important.
      [B] I just want to make some coffee.
      [C] I want to plan the next few weeks.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to remember something important."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I just want to make some coffee."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to plan the next few weeks."
          
          f.puts old_script
        }
      end
    end
    
    # Do you plan far ahead, or at the last minute?    
    def self.planning
      system("clear")
    
      print "
      Do you like to plan at the last minute?
      
      [A] I think I forgot to get something.
      [B] I think I got all my things.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I forgot to get something."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I got all my things."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I got all my things."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer respect or love
    def self.issues_of_respect
      system("clear")
    
      print "
      Do you want to be loved?
      
      [A] I want to have your respect.
      [B] Do you love me?
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to have your respect."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Do you love me?"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Do you love me?"
          
          f.puts old_script
        }
      end
    end
    
    # Do you get warn out at parties or fired up?
    def self.introversion
      system("clear")
    
      print "
      Do you find large crowds exhausting?
      
      [A] You are presently overcrowding me.
      [B] I want to find more friends.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "You are presently overcrowding me."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to find more friends."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to find more friends."
          
          f.puts old_script
        }
      end
    end
    
    # Do you fit in, or stand out like a sore thumb?
    def self.stand_out
      system("clear")
    
      print "
      Do you like to draw attention to yourself?
      
      [A] Ladies and gentlemen, may I have your attention?
      [B] Don't look at me please.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Ladies and gentlemen, may I have your attention?"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Don't look at me please."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Don't look at me please."
          
          f.puts old_script
        }
      end
    end
    
    # Do you keep your options open, or commit to a task?
    def self.commitment
      system("clear")
    
      print "
      Do you like to finish your work?
      
      [A] I want to finish this project I've been working on.
      [B] The project I had in mind can wait.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to finish this project I've been working on."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "The project I had in mind can wait."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "The project I had in mind can wait."
          
          f.puts old_script
        }
      end
    end
    
    # Do you want to fix other people, or do like being fixed?
    def self.fixing_others
      system("clear")
    
      print "
      Do you like to fix other people?
      
      [A] I want to talk about my problems.
      [B] I want others to talk about their problems.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to talk about my problems."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want others to talk about their problems."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want others to talk about their problems."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer to talk, or be talked to?
    def self.conversational
      system("clear")
    
      print "
      Do you like to talk or be talked to?
      
      [A] Please! You're being condescending!
      [B] Let me give you a rundown of things.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Please! You're being condescending!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me give you a rundown of things."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me give you a rundown of things."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer to tell the exact event, or the meaning behind it.
    def self.event_recall
      system("clear")
    
      print "
      Do you like to recall the exact events?
      
      [A] Let me tell you exactly how my day went!
      [B] I want to know what just happened meant!
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Let me tell you exactly how my day went"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to know what just happened meant!"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to know what just happened meant!"
          
          f.puts old_script
        }
      end
    end
    
    # Do you get work done right away or delay it?
    def self.procrastination
      system("clear")
    
      print "
      Do you like to finish your work?
      
      [A] I already have my old project finished.
      [B] I think I still haven't finished the last project.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I already have my old project finished."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I still haven't finished the last project."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I still haven't finished the last project."
          
          f.puts old_script
        }
      end
    end
    
    # Do you follow your heart or your head?
    def self.mind_or_heart
      system("clear")
    
      print "
      Do you life your life with feelings?
      
      [A] Ha! Good one! But give me a real question.
      [B] Lets talk about things I've been brainstorming.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Ha! Good one! But give me a real question."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Lets talk about things I've been brainstorming."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Lets talk about things I've been brainstorming."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer to stay at home or go out?
    def self.home_alone
      system("clear")
    
      print "
      Do you like to stay at home?
      
      [A] How is where the heart is, and my importantly--my bed.
      [B] I'm getting some cabin fever at the moment.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "How is where the heart is, and my importantly--my bed."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I'm getting some cabin fever at the moment."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I'm getting some cabin fever at the moment."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer the big picture or the forest?
    def self.big_picture
      system("clear")
    
      print "
      Do you want the big picture?
      
      [A] Give me a break down of every single detail.
      [B] What do all those details mean?
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a break down of every single detail."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "What do all those details mean?"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "What do all those details mean?"
          
          f.puts old_script
        }
      end
    end
    
    # Do you do things on the fly, or plan ahead?
    def self.on_the_fly
      system("clear")
    
      print "
      Do you do things at the spur of the moment?
      
      [A] I want to go see a movie!
      [B] Can it wait at another point?
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to go see a movie!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Can it wait at another point?"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Can it wait at another point?"
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer retributes or rehabilitation?
    def self.justice_or_compassion
      system("clear")
    
      print "
      Do you prefer a convict executed or spared?
      
      [A] Off with your head!
      [B] Eh, no worries.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Off with your head!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Eh, no worries."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Eh, no worries."
          
          f.puts old_script
        }
      end
    end
    
    # Do you find it easy to yell at others?
    def self.yelling_at_others
      system("clear")
    
      print "
      Do you like to yell at other people?
      
      [A] Why do I have to yell at you so much!
      [B] If I have to yell at you, it's not worth explaining.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Why do I have to yell at you so much!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "If I have to yell at you, it's not worth explaining."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "If I have to yell at you, it's not worth explaining."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer speculating about the theory or practicing it?
    def self.theory_or_practice
      system("clear")
    
      print "
      Do you want to know the theory of stuff?
      
      [A] Give me a break of Conflict Theory!
      [B] Lets be practical with our conversation.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Give me a break of Conflict Theory!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Lets be practical with our conversation."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Lets be practical with our conversation."
          
          f.puts old_script
        }
      end
    end
    
    # Do you work hard or slack off?
    def self.work_ethic
      system("clear")
    
      print "
      Do you like to work hard?
      
      [A] My back aches, but the math equation is finished.
      [B] I think several hours has gone by.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "My back aches, but the math equation is finished."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think several hours has gone by."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think several hours has gone by."
          
          f.puts old_script
        }
      end
    end
    
    # Do you feel comfortable with your emotions?
    def self.comfort_of_emotions
      system("clear")
    
      print "
      Do you feel comfortable with your emotions?
      
      [A] Not sure how to sort out my feelings.
      [B] Oh god! Let me tell you everything.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Not sure how to sort out my feelings."
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Oh god! Let me tell you everything."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Oh god! Let me tell you everything."
          
          f.puts old_script
        }
      end
    end
    
    # Do you like to perform in front of others?
    def self.performance
      system("clear")
    
      print "
      Do you like to perform in front of others?
      
      [A] I want to get some tap shoes and a piano!
      [B] I think I'll hide behind you.
      
      >> "; answer = gets.chomp
      
      # Tweak the answers.
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to get some tap shoes and a piano!"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I'll hide behind you."
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I think I'll hide behind you."
          
          f.puts old_script
        }
      end
    end
    
    # Do you prefer to know why something happened, or who, what, and when? Or both.
    def self.what_is_that
      system("clear")
    
      print "
      Do you like to know the reason behind things?
      
      [A] Why do you think that happened?
      [B] Tell me who did it, what they did, and when!
      [C] I want to know the why and who what when.
      
      >> "; answer = gets.chomp
      
      if    answer == "A" # Writes A answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Why do you think that happened?"
          
          f.puts old_script
        }
      elsif answer == "B" # Writes B answer to script file.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "Tell me who did it, what they did, and when!"
          
          f.puts old_script
        }
      else                # Picks a default answer.
        old_script = File.read("data/script.txt")
      
        open("data/script.txt", "w") { |f|
          f.puts "I want to know the why and who what when."
          
          f.puts old_script
        }
      end
    end
    
    # Operate the Default Quiz
    def self.operate_quiz
      Syncmind::PersonalityQuiz.create_data_folder
      Syncmind::PersonalityQuiz.memory
      Syncmind::PersonalityQuiz.critical_thinking
      Syncmind::PersonalityQuiz.alone_time
      Syncmind::PersonalityQuiz.accepts_things
      Syncmind::PersonalityQuiz.cleanliness
      Syncmind::PersonalityQuiz.automatic_decisions
      Syncmind::PersonalityQuiz.relaxation_check
      Syncmind::PersonalityQuiz.easy_answers
      Syncmind::PersonalityQuiz.organizational
      Syncmind::PersonalityQuiz.hurt_feelings
      Syncmind::PersonalityQuiz.group_focus
      Syncmind::PersonalityQuiz.retrospective
      Syncmind::PersonalityQuiz.planning
      Syncmind::PersonalityQuiz.issues_of_respect
      Syncmind::PersonalityQuiz.introversion
      Syncmind::PersonalityQuiz.stand_out
      Syncmind::PersonalityQuiz.commitment
      Syncmind::PersonalityQuiz.fixing_others
      Syncmind::PersonalityQuiz.conversational
      Syncmind::PersonalityQuiz.event_recall
      Syncmind::PersonalityQuiz.procrastination
      Syncmind::PersonalityQuiz.mind_or_heart
      Syncmind::PersonalityQuiz.home_alone
      Syncmind::PersonalityQuiz.big_picture
      Syncmind::PersonalityQuiz.on_the_fly
      Syncmind::PersonalityQuiz.justice_or_compassion
      Syncmind::PersonalityQuiz.yelling_at_others
      Syncmind::PersonalityQuiz.theory_or_practice
      Syncmind::PersonalityQuiz.work_ethic
      Syncmind::PersonalityQuiz.comfort_of_emotions
      Syncmind::PersonalityQuiz.performance
      Syncmind::PersonalityQuiz.what_is_that
    end
  end
  
  class OperateChatBot
  
    def self.analyze_script
        
      loop do
        require "naive_bayes"
        
        # Personality statistics and files.
        iteration           = File.read("data/iteration.txt") # Controls the sleep time between personality details and input.
        script              = File.readlines("data/script.txt") # The script file the mindfile reads from.
        personality_details = script.sample # Personality detail read from a script.
        
        bot_name  = File.read("bot_identity/bot_name.txt").strip
        your_name = File.read("your_identity/your_name.txt").strip
        
        puts "#{bot_name}: #{personality_details}"
        
        a = NaiveBayes.new(:pets, :hobbies, :jobs, :skills, :weather)
        
        # Pets
        a.train(:pets,      "dog", "word")
        a.train(:pets,      "cat", "word")
        a.train(:pets,      "rat", "word")
        a.train(:pets,   "gerbil", "word")
        a.train(:pets,  "hamster", "word")
        a.train(:pets,    "snake", "word")
        a.train(:pets,   "monkey", "word")
        a.train(:pets,     "dog.", "word")
        a.train(:pets,     "cat.", "word")
        a.train(:pets,     "rat.", "word")
        a.train(:pets,  "gerbil.", "word")
        a.train(:pets, "hamster.", "word")
        a.train(:pets,   "snake.", "word")
        a.train(:pets,  "monkey.", "word")
        a.train(:pets,     "dog;", "word")
        a.train(:pets,     "cat;", "word")
        a.train(:pets,     "rat;", "word")
        a.train(:pets,  "gerbil;", "word")
        a.train(:pets, "hamster;", "word")
        a.train(:pets,   "snake;", "word")
        a.train(:pets,  "monkey;", "word")
        a.train(:pets,     "dog:", "word")
        a.train(:pets,     "cat:", "word")
        a.train(:pets,     "rat:", "word")
        a.train(:pets,  "gerbil:", "word")
        a.train(:pets, "hamster:", "word")
        a.train(:pets,   "snake:", "word")
        a.train(:pets,  "monkey:", "word")
        a.train(:pets,     "dog?", "word")
        a.train(:pets,     "cat?", "word")
        a.train(:pets,     "rat?", "word")
        a.train(:pets,  "gerbil?", "word")
        a.train(:pets, "hamster?", "word")
        a.train(:pets,   "snake?", "word")
        a.train(:pets,  "monkey?", "word")

        # Hobbies
        a.train(:hobbies,           "sing", "word")
        a.train(:hobbies,     "illustrate", "word")
        a.train(:hobbies,           "draw", "word")
        a.train(:hobbies,          "write", "word")
        a.train(:hobbies,         "widdle", "word")
        a.train(:hobbies,          "dance", "word")
        a.train(:hobbies,           "clog", "word")
        a.train(:hobbies,          "weave", "word")
        a.train(:hobbies,        "crochet", "word")
        a.train(:hobbies,           "knit", "word")
        a.train(:hobbies,           "swim", "word")
        a.train(:hobbies,           "BDSM", "word")
        a.train(:hobbies,           "game", "word")
        a.train(:hobbies,           "JRPG", "word")
        a.train(:hobbies,         "MMORPG", "word")
        a.train(:hobbies,            "FPS", "word")
        a.train(:hobbies,            "SIM", "word")
        a.train(:hobbies,   "metroidvania", "word")
        a.train(:hobbies,       "football", "word")
        a.train(:hobbies,       "baseball", "word")
        a.train(:hobbies,         "soccer", "word")
        a.train(:hobbies,     "volleyball", "word")
        a.train(:hobbies,     "skateboard", "word")
        a.train(:hobbies,           "bike", "word")
        a.train(:hobbies,          "skate", "word")
        a.train(:hobbies,          "sing.", "word")
        a.train(:hobbies,    "illustrate.", "word")
        a.train(:hobbies,          "draw.", "word")
        a.train(:hobbies,         "write.", "word")
        a.train(:hobbies,        "widdle.", "word")
        a.train(:hobbies,         "dance.", "word")
        a.train(:hobbies,          "clog.", "word")
        a.train(:hobbies,         "weave.", "word")
        a.train(:hobbies,       "crochet.", "word")
        a.train(:hobbies,          "knit.", "word")
        a.train(:hobbies,          "swim.", "word")
        a.train(:hobbies,          "BDSM.", "word")
        a.train(:hobbies,          "game.", "word")
        a.train(:hobbies,          "JRPG.", "word")
        a.train(:hobbies,        "MMORPG.", "word")
        a.train(:hobbies,           "FPS.", "word")
        a.train(:hobbies,           "SIM.", "word")
        a.train(:hobbies,  "metroidvania.", "word")
        a.train(:hobbies,      "football.", "word")
        a.train(:hobbies,      "baseball.", "word")
        a.train(:hobbies,        "soccer.", "word")
        a.train(:hobbies,    "volleyball.", "word")
        a.train(:hobbies,    "skateboard.", "word")
        a.train(:hobbies,          "bike.", "word")
        a.train(:hobbies,         "skate.", "word")
        a.train(:hobbies,          "sing;", "word")
        a.train(:hobbies,    "illustrate;", "word")
        a.train(:hobbies,          "draw;", "word")
        a.train(:hobbies,         "write;", "word")
        a.train(:hobbies,        "widdle;", "word")
        a.train(:hobbies,         "dance;", "word")
        a.train(:hobbies,          "clog;", "word")
        a.train(:hobbies,         "weave;", "word")
        a.train(:hobbies,       "crochet;", "word")
        a.train(:hobbies,          "knit;", "word")
        a.train(:hobbies,          "swim;", "word")
        a.train(:hobbies,          "BDSM;", "word")
        a.train(:hobbies,          "game;", "word")
        a.train(:hobbies,          "JRPG;", "word")
        a.train(:hobbies,        "MMORPG;", "word")
        a.train(:hobbies,           "FPS;", "word")
        a.train(:hobbies,           "SIM;", "word")
        a.train(:hobbies,  "metroidvania;", "word")
        a.train(:hobbies,      "football;", "word")
        a.train(:hobbies,      "baseball;", "word")
        a.train(:hobbies,        "soccer;", "word")
        a.train(:hobbies,    "volleyball;", "word")
        a.train(:hobbies,    "skateboard;", "word")
        a.train(:hobbies,          "bike;", "word")
        a.train(:hobbies,         "skate;", "word")
        a.train(:hobbies,          "sing:", "word")
        a.train(:hobbies,    "illustrate:", "word")
        a.train(:hobbies,          "draw:", "word")
        a.train(:hobbies,         "write:", "word")
        a.train(:hobbies,        "widdle:", "word")
        a.train(:hobbies,         "dance:", "word")
        a.train(:hobbies,          "clog:", "word")
        a.train(:hobbies,         "weave:", "word")
        a.train(:hobbies,       "crochet:", "word")
        a.train(:hobbies,          "knit:", "word")
        a.train(:hobbies,          "swim:", "word")
        a.train(:hobbies,          "BDSM:", "word")
        a.train(:hobbies,          "game:", "word")
        a.train(:hobbies,          "JRPG:", "word")
        a.train(:hobbies,        "MMORPG:", "word")
        a.train(:hobbies,           "FPS:", "word")
        a.train(:hobbies,           "SIM:", "word")
        a.train(:hobbies,  "metroidvania:", "word")
        a.train(:hobbies,      "football:", "word")
        a.train(:hobbies,      "baseball:", "word")
        a.train(:hobbies,        "soccer:", "word")
        a.train(:hobbies,    "volleyball:", "word")
        a.train(:hobbies,    "skateboard:", "word")
        a.train(:hobbies,          "bike:", "word")
        a.train(:hobbies,         "skate:", "word")
        a.train(:hobbies,          "sing?", "word")
        a.train(:hobbies,    "illustrate?", "word")
        a.train(:hobbies,          "draw?", "word")
        a.train(:hobbies,         "write?", "word")
        a.train(:hobbies,        "widdle?", "word")
        a.train(:hobbies,         "dance?", "word")
        a.train(:hobbies,          "clog?", "word")
        a.train(:hobbies,         "weave?", "word")
        a.train(:hobbies,       "crochet?", "word")
        a.train(:hobbies,          "knit?", "word")
        a.train(:hobbies,          "swim?", "word")
        a.train(:hobbies,          "BDSM?", "word")
        a.train(:hobbies,          "game?", "word")
        a.train(:hobbies,          "JRPG?", "word")
        a.train(:hobbies,        "MMORPG?", "word")
        a.train(:hobbies,           "FPS?", "word")
        a.train(:hobbies,           "SIM?", "word")
        a.train(:hobbies,  "metroidvania?", "word")
        a.train(:hobbies,      "football?", "word")
        a.train(:hobbies,      "baseball?", "word")
        a.train(:hobbies,        "soccer?", "word")
        a.train(:hobbies,    "volleyball?", "word")
        a.train(:hobbies,    "skateboard?", "word")
        a.train(:hobbies,          "bike?", "word")
        a.train(:hobbies,         "skate?", "word")
        
        # Jobs
        a.train(:jobs,          "nurse", "word")
        a.train(:jobs,        "officer", "word")
        a.train(:jobs,        "fireman", "word")
        a.train(:jobs,        "cashier", "word")
        a.train(:jobs,        "stocker", "word")
        a.train(:jobs,         "barber", "word")
        a.train(:jobs,        "stylist", "word")
        a.train(:jobs,          "clerk", "word")
        a.train(:jobs,        "butcher", "word")
        a.train(:jobs,       "reporter", "word")
        a.train(:jobs,        "manager", "word")
        a.train(:jobs,          "crane", "word")
        a.train(:jobs,         "lawyer", "word")
        a.train(:jobs,      "cameraman", "word")
        a.train(:jobs,       "engineer", "word")
        a.train(:jobs,          "pilot", "word")
        a.train(:jobs,         "nurse.", "word")
        a.train(:jobs,       "officer.", "word")
        a.train(:jobs,       "fireman.", "word")
        a.train(:jobs,       "cashier.", "word")
        a.train(:jobs,       "stocker.", "word")
        a.train(:jobs,        "barber.", "word")
        a.train(:jobs,       "stylist.", "word")
        a.train(:jobs,         "clerk.", "word")
        a.train(:jobs,       "butcher.", "word")
        a.train(:jobs,      "reporter.", "word")
        a.train(:jobs,       "manager.", "word")
        a.train(:jobs,         "crane.", "word")
        a.train(:jobs,        "lawyer.", "word")
        a.train(:jobs,     "cameraman.", "word")
        a.train(:jobs,      "engineer.", "word")
        a.train(:jobs,         "pilot.", "word")
        a.train(:jobs,         "nurse;", "word")
        a.train(:jobs,       "officer;", "word")
        a.train(:jobs,       "fireman;", "word")
        a.train(:jobs,       "cashier;", "word")
        a.train(:jobs,       "stocker;", "word")
        a.train(:jobs,        "barber;", "word")
        a.train(:jobs,       "stylist;", "word")
        a.train(:jobs,         "clerk;", "word")
        a.train(:jobs,       "butcher;", "word")
        a.train(:jobs,      "reporter;", "word")
        a.train(:jobs,       "manager;", "word")
        a.train(:jobs,         "crane;", "word")
        a.train(:jobs,        "lawyer;", "word")
        a.train(:jobs,     "cameraman;", "word")
        a.train(:jobs,      "engineer;", "word")
        a.train(:jobs,         "pilot;", "word")
        a.train(:jobs,         "nurse:", "word")
        a.train(:jobs,       "officer:", "word")
        a.train(:jobs,       "fireman:", "word")
        a.train(:jobs,       "cashier:", "word")
        a.train(:jobs,       "stocker:", "word")
        a.train(:jobs,        "barber:", "word")
        a.train(:jobs,       "stylist:", "word")
        a.train(:jobs,         "clerk:", "word")
        a.train(:jobs,       "butcher:", "word")
        a.train(:jobs,      "reporter:", "word")
        a.train(:jobs,       "manager:", "word")
        a.train(:jobs,         "crane:", "word")
        a.train(:jobs,        "lawyer:", "word")
        a.train(:jobs,     "cameraman:", "word")
        a.train(:jobs,      "engineer:", "word")
        a.train(:jobs,         "pilot:", "word")
        
        # Skills
        a.train(:skills,   "codebreak", "word")
        a.train(:skills,        "cook", "word")
        a.train(:skills,       "climb", "word")
        a.train(:skills,      "yoddle", "word")
        a.train(:skills,  "blacksmith", "word")
        a.train(:skills,  "codebreak.", "word")
        a.train(:skills,       "cook.", "word")
        a.train(:skills,      "climb.", "word")
        a.train(:skills,     "yoddle.", "word")
        a.train(:skills, "blacksmith.", "word")
        a.train(:skills,  "codebreak;", "word")
        a.train(:skills,       "cook;", "word")
        a.train(:skills,      "climb;", "word")
        a.train(:skills,     "yoddle;", "word")
        a.train(:skills, "blacksmith;", "word")
        a.train(:skills,  "codebreak:", "word")
        a.train(:skills,       "cook:", "word")
        a.train(:skills,      "climb:", "word")
        a.train(:skills,     "yoddle:", "word")
        a.train(:skills, "blacksmith:", "word")
        a.train(:skills,  "codebreak?", "word")
        a.train(:skills,       "cook?", "word")
        a.train(:skills,      "climb?", "word")
        a.train(:skills,     "yoddle?", "word")
        a.train(:skills, "blacksmith?", "word")
        
        # Weather
        a.train(:weather,   "sunny", "word")
        a.train(:weather,   "rainy", "word")
        a.train(:weather,  "cloudy", "word")
        a.train(:weather,   "foggy", "word")
        a.train(:weather,   "humid", "word")
        a.train(:weather,  "sunny.", "word")
        a.train(:weather,  "rainy.", "word")
        a.train(:weather, "cloudy.", "word")
        a.train(:weather,  "foggy.", "word")
        a.train(:weather,  "humid.", "word")
        a.train(:weather,  "sunny;", "word")
        a.train(:weather,  "rainy;", "word")
        a.train(:weather, "cloudy;", "word")
        a.train(:weather,  "foggy;", "word")
        a.train(:weather,  "humid;", "word")
        a.train(:weather,  "sunny:", "word")
        a.train(:weather,  "rainy:", "word")
        a.train(:weather, "cloudy:", "word")
        a.train(:weather,  "foggy:", "word")
        a.train(:weather,  "humid:", "word")
        a.train(:weather,  "sunny?", "word")
        a.train(:weather,  "rainy?", "word")
        a.train(:weather, "cloudy?", "word")
        a.train(:weather,  "foggy?", "word")
        a.train(:weather,  "humid?", "word")
        
        # Chatbot process for asking about pets.
        print "#{bot_name}: How do you do?\n#{your_name}: "
        b = gets.chomp
        
        if b == "Goodbye"
          abort
        end
  
        # Classify b and convert to string.
        a_class     = a.classify(*b)
        result      = a_class[0]
        probability = a_class[1].to_f
        decision    = result.to_s
        
        # Responce with a pet, hobby, job, skill, or weather rejoinder based on probability.
        if    decision ==    "pets"
              if probability >= 1.7741802839285145e-10
                puts "#{bot_name}: Is that a nice pet?"
              else
                puts "#{bot_name}: Sorry but that's not a pet."
              end
        elsif decision == "hobbies"
              if probability >= 1.7741802839285145e-10
                puts "#{bot_name}: Can you guide me in that hobby?"
              else
                puts "#{bot_name}: I don't think that's a hobby."
              end
        elsif decision ==    "jobs"
              if probability >= 1.7741802839285145e-10
                puts "#{bot_name}: Do you like that job?"
              else
                puts "#{bot_name}: That doesn't seem like a real job."
              end
        elsif decision ==  "skills"
              if probability >= 1.7741802839285145e-10
                puts "#{bot_name}: That sounds like an interesting skill."
              else
                puts "#{bot_name}: Have you ever considered switching skills?"
              end
        elsif decision == "weather"
              if probability >= 1.7741802839285145e-10
                puts "#{bot_name}: The weather is #{decision}?"
              else
                puts "#{bot_name}: That weather doesn't seem likely."
              end
        else
          puts "#{bot_name}: I'm not sure what you mean."
        end
        
      end
      
    end 
  end
  
end
